{
    "$graph": [
        {
            "label": "assm_assm_blastn_create_jobs",
            "class": "CommandLineTool",
            "baseCommand": "assm_assm_blastn_create_jobs",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "q.mft",
                            "entry": "${\n  var blob = '# q.mft created for assm_assm_blastn_create_jobs from input \"queries_gc_id_list\" File\\n'; \n  if(inputs.queries_gc_id_list != null) { blob += inputs.queries_gc_id_list.path + '\\n'; } \n  return blob; \n}"
                        },
                        {
                            "entryname": "t.mft",
                            "entry": "${\n  var blob = '# t.mft created for assm_assm_blastn_create_jobs from input \"subjects_gc_id_list\" File\\n'; \n  if(inputs.subjects_gc_id_list != null) { blob += inputs.subjects_gc_id_list.path + '\\n'; } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "arguments": [
                "-query-assemblies-manifest",
                "q.mft",
                "-target-assemblies-manifest",
                "t.mft"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-affinity-bin"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/affinity_bin"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/output_xml_file_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#assm_assm_blastn_create_jobs.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#assm_assm_blastn_create_jobs.cwl/subjects_gc_id_list"
                }
            ],
            "id": "#assm_assm_blastn_create_jobs.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_file_name)"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/output"
                }
            ]
        },
        {
            "label": "assm_assm_blastn_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "queries-and-targets.mft",
                            "entry": "${\n  var blob = '# queries-and-targets.mft created for assm_assm_blastn_wnode from input \"target_set\" File\\n'; \n  if(inputs.target_set != null) { \n    for(var i=0; i<inputs.target_set.length; i++) {\n      blob += inputs.target_set[i].path + '\\n'; \n    }\n  } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "baseCommand": "assm_assm_blastn_wnode",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-compart"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/compart"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-gapextend"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gapextend"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-gapopen"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gapopen"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc-cache"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gc_cache"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-bases-per-call"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/max_bases_per_call"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-merge-align-filter"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/merge_align_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-merge-engine"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/merge_engine"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/target_set"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "queries-and-targets.mft",
                    "inputBinding": {
                        "prefix": "-target-set-manifest"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/target_set_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-task"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/task"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "-use-common-components"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/use_common_components"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-window_size"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/window_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/word_size"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-workers-per-cpu"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/workers_per_cpu"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/outdir"
                }
            ],
            "id": "#assm_assm_blastn_wnode.cwl"
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "arguments": [
                "-produce-empty-file"
            ],
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an XML input \n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit-xml.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": null,
                    "id": "#gpx_qsubmit-xml.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit-xml.cwl"
        },
        {
            "label": "assm_assm_blastn_wnode",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/affinity"
                },
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/compart"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/gapextend"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/gapopen"
                },
                {
                    "type": "File",
                    "id": "#main/gc_cache"
                },
                {
                    "type": "Directory",
                    "id": "#main/gc_seq_cache"
                },
                {
                    "type": "File",
                    "id": "#main/gencoll_asn"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/max_bases_per_call"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/merge_align_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/merge_engine"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/nogenbank"
                },
                {
                    "type": "File",
                    "id": "#main/queries_gc_id_list"
                },
                {
                    "type": "File",
                    "id": "#main/ref_gencoll_asn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/soft_masking"
                },
                {
                    "type": "File",
                    "id": "#main/subjects_gc_id_list"
                },
                {
                    "type": "string",
                    "id": "#main/task"
                },
                {
                    "type": "boolean",
                    "id": "#main/use_common_components"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/window_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/word_size"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#main/workers_per_cpu"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/gpx_qdump/output",
                    "id": "#main/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#assm_assm_blastn_create_jobs.cwl",
                    "in": [
                        {
                            "default": 10,
                            "id": "#main/assm_assm_blastn_create_jobs/affinity_bin"
                        },
                        {
                            "source": "#main/queries_gc_id_list",
                            "id": "#main/assm_assm_blastn_create_jobs/queries_gc_id_list"
                        },
                        {
                            "source": "#main/subjects_gc_id_list",
                            "id": "#main/assm_assm_blastn_create_jobs/subjects_gc_id_list"
                        }
                    ],
                    "out": [
                        "#main/assm_assm_blastn_create_jobs/output"
                    ],
                    "id": "#main/assm_assm_blastn_create_jobs"
                },
                {
                    "run": "#assm_assm_blastn_wnode.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/asn_cache",
                                "#main/gc_seq_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/assm_assm_blastn_wnode/asn_cache"
                        },
                        {
                            "source": "#main/compart",
                            "id": "#main/assm_assm_blastn_wnode/compart"
                        },
                        {
                            "source": "#main/evalue",
                            "id": "#main/assm_assm_blastn_wnode/evalue"
                        },
                        {
                            "source": "#main/gapextend",
                            "id": "#main/assm_assm_blastn_wnode/gapextend"
                        },
                        {
                            "source": "#main/gapopen",
                            "id": "#main/assm_assm_blastn_wnode/gapopen"
                        },
                        {
                            "source": "#main/gc_cache",
                            "id": "#main/assm_assm_blastn_wnode/gc_cache"
                        },
                        {
                            "source": "#main/gpx_qsubmit/jobs",
                            "id": "#main/assm_assm_blastn_wnode/input_jobs"
                        },
                        {
                            "source": "#main/max_bases_per_call",
                            "id": "#main/assm_assm_blastn_wnode/max_bases_per_call"
                        },
                        {
                            "source": "#main/max_target_seqs",
                            "id": "#main/assm_assm_blastn_wnode/max_target_seqs"
                        },
                        {
                            "source": "#main/merge_align_filter",
                            "id": "#main/assm_assm_blastn_wnode/merge_align_filter"
                        },
                        {
                            "source": "#main/merge_engine",
                            "id": "#main/assm_assm_blastn_wnode/merge_engine"
                        },
                        {
                            "source": "#main/soft_masking",
                            "id": "#main/assm_assm_blastn_wnode/soft_masking"
                        },
                        {
                            "source": [
                                "#main/gencoll_asn",
                                "#main/ref_gencoll_asn"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/assm_assm_blastn_wnode/target_set"
                        },
                        {
                            "source": "#main/task",
                            "id": "#main/assm_assm_blastn_wnode/task"
                        },
                        {
                            "source": "#main/use_common_components",
                            "id": "#main/assm_assm_blastn_wnode/use_common_components"
                        },
                        {
                            "source": "#main/window_size",
                            "id": "#main/assm_assm_blastn_wnode/window_size"
                        },
                        {
                            "source": "#main/word_size",
                            "id": "#main/assm_assm_blastn_wnode/word_size"
                        },
                        {
                            "source": "#main/workers_per_cpu",
                            "id": "#main/assm_assm_blastn_wnode/workers_per_cpu"
                        }
                    ],
                    "out": [
                        "#main/assm_assm_blastn_wnode/outdir"
                    ],
                    "id": "#main/assm_assm_blastn_wnode"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#main/assm_assm_blastn_wnode/outdir",
                            "id": "#main/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#main/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#main/gpx_qdump/output"
                    ],
                    "id": "#main/gpx_qdump"
                },
                {
                    "run": "#gpx_qsubmit-xml.cwl",
                    "in": [
                        {
                            "source": "#main/affinity",
                            "id": "#main/gpx_qsubmit/affinity"
                        },
                        {
                            "source": [
                                "#main/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": "#main/nogenbank",
                            "id": "#main/gpx_qsubmit/nogenbank"
                        },
                        {
                            "source": "#main/assm_assm_blastn_create_jobs/output",
                            "id": "#main/gpx_qsubmit/xml_jobs"
                        }
                    ],
                    "out": [
                        "#main/gpx_qsubmit/jobs"
                    ],
                    "id": "#main/gpx_qsubmit"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
